use Test::Simple tests => 3;

use strict;
use DE_EPAGES::Core::API::Process qw(
    GetProcessMemory
    GetCurrentProcessID
    SetProcessPriority
);

# suppress warings from Win32::API::Struct
local $SIG{__WARN__} = sub {
    my ($Message) = @_;
    print STDERR $Message unless $Message =~ /Win32\/API\/Struct/;
};

my $PID = GetCurrentProcessID();
ok( 0 != $PID, "GetCurrentProcessID" );

my $MemUsage = GetProcessMemory( $PID );
ok( $MemUsage > 5000000, "GetProcessMemory" );

SetProcessPriority( $PID, 'ABOVE_NORMAL' );
ok ( 1, 'SetProcessPriority' );
