-- #103
CREATE TABLE customer (
    customerid           int           not null
,   shopid               int           not null
,   customergroupid      int           null
,   billingaddressid     int           null
,   ishtmlemailallowed   bit           not null
,   isdoorderallowed     bit           not null
,   taxareaid            int           null
,   taxmodel             bit           not null
,   comment              nvarchar(255)  null

,   constraint pk_customer                      primary key (customerid)
,   constraint fk_customer_object               foreign key (customerid)
        references object                           (objectid)
,   constraint fk_customer_address              foreign key (billingaddressid)
        references address                          (addressid)
,   constraint fk_customer_customergroup        foreign key (customergroupid)
        references customergroup                    (customergroupid)
,   constraint fk_customer_shop                 foreign key (shopid)
        references shop                             (shopid)
,   constraint fk_customer_taxarea              foreign key (taxareaid)
        references taxarea                          (taxareaid)
) LOCK DATAROWS
GO
CREATE INDEX i_customer_shop ON customer (shopid)
GO
CREATE INDEX i_customer_group ON customer (customergroupid)
GO
