/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.design.widget.Stylegrouptree $Revision: 1.5.2.1 $

*/
dojo.provide("epages.cartridges.de_epages.design.widget.Stylegrouptree");
dojo.require("dijit.Tree");

dojo.declare(
	"epages.cartridges.de_epages.design.widget.Stylegrouptree",
	dijit.Tree,
	{
		listId: "",
		persist: false,
		selectedId: "",

		onClick: function(/* dojo.data */ item, /*TreeNode*/ node) {
			this._expandNode(node);
			this.focusNode(node);

			dojo.publish(this.listId+'/select', [item, node]);
		},

		getStoreItemByIdentity: function(identity) {
			var getitem = undefined;
			this.model.store.fetchItemByIdentity( {
				identity : identity,
				scope    : this,
				onItem   : function(item) {
					getitem = item;
				}
			});
			return getitem;
		},

		onLoad:function(){
			this.inherited('onLoad', arguments);
			var treeNode = this.expandByIdentity(this.selectedId);
			return treeNode;
		},

		expandByIdentity: function(identity) {
		// summary: expands treenode specified by indetifier
		// description: you need to provide the parentObjectId attribute in your source tree data (items) / they are not provided by your data store automatically
			var leafItem = this.getStoreItemByIdentity(identity);
			var item = leafItem;
			var items = [];
			items.push(leafItem.objectId[0]);
			while(item.parentObjectId) {
				item = this.getStoreItemByIdentity(item.parentObjectId);
				items.push(item.objectId[0]);
			}
			items.reverse();
			rootNode = this._itemNodesMap[items[0]];
			if(rootNode){
				this.attr('path', items);
				var leafNode = this._itemNodesMap[identity];
				//this.lastFocused = leafNode;
				return leafNode;
			}
			else {
				return undefined;
			}
		},

		focusNode: function(node) {
			this.blurNode();
			try{
				node.labelNode.focus();
			}
			catch(e){
				console.debug(e);
			}
			dojo.addClass(node.labelNode,"Selected");
			this.lastFocused = node;
		},

		blurNode: function() {
			var node = this.lastFocused;
			if(!node){
				return;
			}
			dojo.removeClass(node.labelNode, "Selected");
			var labelNode = node.labelNode;
			dojo.removeClass(labelNode, "dijitTreeLabelFocused");
			labelNode.setAttribute("tabIndex", "-1");
			this.lastFocused = null;
		},

		getIconClass: function(/*dojo.data.Item*/ item){
				return '';
		},
		getLabelClass: function(/*dojo.data.Item*/ item){
			// summary: user overridable function to return CSS class name to display label
			//if no return value is set dojo adds a class "undefined" to every label in the tree
			return '';
		}
	}
);