/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.design.widget.Toolspaces $Revision: 1.17.58.1 $

*/
dojo.provide("epages.cartridges.de_epages.design.widget.Toolspaces");
dojo.require("epages.widget.LocalizedWidget");
dojo.require("epages.widget.Validateinput");
dojo.require("dijit._Container");

dojo.declare(
	"epages.cartridges.de_epages.design.widget.Toolspaces",
	[epages.widget.LocalizedWidget],
	{
		/**
		 * public properties
		 */
		label           : '',
		top             : '',
		bottom          : '',
		left            : '',
		right           : '',
		spaceType       : '', /* Margin, Padding */
		objectId        : '',
		lockLevel       : '', /* locklevel > 0 => attribute locked */
		/**
		 * widget properties
		 */

		templatePath      : dojo.moduleUrl('epages.cartridges.de_epages.design.widget' , 'templates/Toolspaces.html'),
		translationName   : dojo.moduleUrl('epages.cartridges.de_epages.design.widget' , 'templates/translation'),
		imagePath         : epages.themeUrl('images'),
		widgetsInTemplate : true,

		// override
		postCreate  : function() {
                // summary: initalize widget
		// description: show lock icon and disable input fields if locklevel is passed
			if(this.spaceType.match("Margin"))
				this.bubbleHelpMarginNode.style.display="";
			else if(this.spaceType.match("Padding"))
				this.bubbleHelpPaddingNode.style.display="";
			this.inherited("postCreate", arguments);
			if(this.lockLevel == '1' || this.lockLevel == '2') {
					this.topInputWidget.domNode.disabled=true;
					this.bottomInputWidget.domNode.disabled=true;
					this.leftInputWidget.domNode.disabled=true;
					this.rightInputWidget.domNode.disabled=true;
					this.domNode.className+=" disabled";
			}
		}
});
