IF OBJECT_ID('i_LineItemPaymentDocdataPay') IS NOT NULL
    DROP PROCEDURE i_LineItemPaymentDocdataPay
GO
CREATE PROCEDURE i_LineItemPaymentDocdataPay (
    @LineItemPaymentDocdataPayID int          
,   @CurrencyID           char(3)      
,   @Amount               money        
,   @TransID              varchar(20)  = null
,   @TransTime            datetime     = null
,   @TransStatus          varchar(20)  = null
,   @ModTime              datetime     = null
,   @TransHash            varchar(80)  = null
) AS BEGIN
    DECLARE @TransactionCount int
    SELECT @TransactionCount = @@trancount

    IF @TransactionCount > 0 SAVE  TRANSACTION ti_lineitempaymentdocdatapay
    ELSE                     BEGIN TRANSACTION ti_lineitempaymentdocdatapay

        INSERT INTO lineitempaymentdocdatapay
               ( lineitempaymentdocdatapayid, currencyid, amount, transid, transtime, transstatus, modtime, transhash)
        SELECT  @LineItemPaymentDocdataPayID,@CurrencyID,@Amount,@TransID,@TransTime,@TransStatus,@ModTime,@TransHash

        IF NOT @@transtate IN (0, 1)
        BEGIN
            ROLLBACK TRANSACTION ti_lineitempaymentdocdatapay
            RETURN 1
        END

    IF @TransactionCount = 0
        COMMIT TRANSACTION ti_lineitempaymentdocdatapay
    RETURN 0
END
GO
