/*
	Copyright (c) 2006-2010, epages Software GmbH
	All Rights Reserved.

	epages.widget.InlineTinyMCE $Revision: 1.1.4.1 $

*/
dojo.provide("epages.InlineTinyMCEController");

epages.InlineTinyMCEController = {
		/**
		 * private properties
		 */
		_editorStack:[],
		_interval: undefined,
		_readyForNext: true,

		createEditors:function(){
			//summary: create interval wich checks if there are editors inside the stack
			//build editors from stack and clear stack
			//stop interval if stack is empty
			this._interval = window.setInterval(function(){
				dojo.publish("uimessage/startBusy", ["InlineTinyMCEController"]);
				if(epages.InlineTinyMCEController._readyForNext && epages.InlineTinyMCEController._editorStack.length > 0){
					epages.InlineTinyMCEController._readyForNext = false;
					epages.InlineTinyMCEController.createEditor();
				}
				else{
					dojo.publish("uimessage/stopBusy", ["InlineTinyMCEController"]);
					window.clearInterval(epages.InlineTinyMCEController._interval);
				}
			},10);
		},

		createEditor:function(){
			//summary: create single editor from stack
			var editorWidget  = this._editorStack.shift();
			editorWidget._buildEditor();
			epages.InlineTinyMCEController._readyForNext = true;
		},

		addToStack:function(editorWidget){
			//summary: add editorWidget to stack
			this._editorStack.push(editorWidget);
		}
};

dojo.addOnLoad(function() {
	epages.InlineTinyMCEController.createEditors();
});