/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.browser $Revision: 1.17.4.1 $

*/
dojo.provide('epages.browser');
dojo.require('epages.epages');

epages.Browser = {};

(function() {
	var browser = epages.Browser;
	browser.engine = "Unknown";
	browser.version = "Unknown";
	if(window.opera) {
		browser.engine = "Presto";
		browser.version = window.opera.version();
	}else {
		var versionString = (navigator.appVersion + navigator.userAgent).toLowerCase();
		if(versionString.match("iemobile") || versionString.match("windows ce")) {
			// ie on smartphone
			browser.engine = "MSIE";
			browser.version = 6;
		}else if(versionString.match("msie")) {
			browser.engine = "MSIE";
			browser.version = (window.XDomainRequest && dojo.isIE == 7) ? 8 : dojo.isIE;
			// ...and finally some testing for IE6 with faked IE7 appVersion & userAgent
			var testNode = document.createElement("b");
			testNode.style.cssText = "max-height:1";
			if(testNode.style.cssText.match("max-height")) {browser.version = 6}
		}else if(versionString.match("webkit")) {
			browser.engine = "WebKit";
			browser.version = parseFloat(versionString.split("/")[2]) || dojo.isSafari;
			browser.webkitversion = parseFloat(versionString.match(/applewebkit\/([\d\.]+)/)[1]);
		}else if(versionString.match("gecko")) {
			browser.engine = "Gecko";
			browser.version = dojo.isFx || dojo.isFF || parseFloat(versionString.split("/").pop()) /* handling firefox versions with alternate ua */;
		}else if(versionString.match("khtml")) {
			browser.engine = "KHTML";
		}
	}
	browser.version = browser.version.toString().replace(/\./g, "_");
	(document.documentElement || document.body.parentNode).className += " " + browser.engine + " " + browser.engine + browser.version;
})();

(function () { /* detect flash version (limted to flash version 15) */
	for(var flashVersion = 15; flashVersion > 3; flashVersion--) {
		var flashAble = true;
		if(navigator.plugins.length) {
			try {var flashPlugin = navigator.plugins["Shockwave Flash"].description;
				flashAble = flashPlugin.slice(flashPlugin.indexOf(".") - 2, flashPlugin.indexOf(".")) >= flashVersion;
			}catch(e) {flashAble = false}
		}else {
			try {new ActiveXObject("ShockwaveFlash.ShockwaveFlash." + flashVersion)}
			catch(e) {flashAble = false}
		}
		if(flashAble) {
			epages.Browser.flashVersion = flashVersion;
			break;
		}
	}
})();