/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

  epages.lang.hitch $Revision: 1.7.52.1 $

*/
dojo.provide('epages.lang.hitch');
dojo.require('epages.lang.clipboard');

epages.lang.hitch = function (/*Object*/o, /*function*/func, /*Array?*/parameters) {
	if (o === undefined && func === undefined && parameters === undefined) {
		// it seems to be a constructor
		return;
	} else {
		if (parameters === undefined) {
			// no given parameters ==> use default hitch function
			return dojo.hitch(o, func);
		}
		var clipboardParams = [];
		for (var i = 0; i < parameters.length; i++) {
			var clipboardIndex = epages.lang.hitch.prototype.clipBoard.add(parameters[i]);
			clipboardParams.push("epages.lang.hitch.prototype.clipBoard.get(" + clipboardIndex + ")");
		}
		// find out methods name in o
		if (typeof(func) == "string") {
			var funcName = func;
		} else {
			for (member in o) {
				if (typeof o[member] == "function" &&
						o[member] == func) {
					var funcName = member;
					break;
				}
			}
		}
		var returnValue;
		if (funcName === undefined) {
			// not a member function
			returnValue = eval("dojo.hitch(o, function() { func(" + clipboardParams.join(", ") + "); });");
		} else {
			// If possible the following line should be replaced with something
			// that does a function call and provides function parameters as an array
			// or something else non-static.
			returnValue = eval("dojo.hitch(o, function() { o." + funcName + "(" + clipboardParams.join(", ") + "); });");
		}
		return returnValue;
	}
};

epages.lang.hitch.prototype = {
	clipBoard : new epages.lang.Clipboard()
};
