/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

  epages.lang.hitch $Revision: 1.2.52.1 $

*/
dojo.provide('epages.lang.hitch_test');
dojo.require('epages.lang.hitch');

dojo.extend(epages.lang.hitch, {

	test: function(eTest) {

		eTest.setPlanned(3);

		var counter = 0;
		var expected = [true, false, false];

		var Example = function(eTest) {
			this.eTest = eTest;
			var localVar = "test";

			// this works - the new hitch function
			button1 = document.createElement("input");
			button1.type = "button";
			button1.value = "test 1";
			button1.style.display = "none";
			button1.onclick = epages.lang.hitch(this, this.showProperty1, [localVar]);

			// this does not work - functionality of the old hitch function
			button2 = document.createElement("input");
			button2.type = "button";
			button2.value = "test 2";
			button2.style.display = "none";
			button2.onclick = epages.lang.hitch(this, function() { this.showProperty1(localVar); });

			// this does not work too - the old hitch function
			button3 = document.createElement("input");
			button3.type = "button";
			button3.value = "test 3";
			button3.style.display = "none";
			button3.onclick = epages.lang.hitch(this, function() { this.showProperty1(localVar); });

			document.body.appendChild(button1);
			document.body.appendChild(button2);
			document.body.appendChild(button3);
			// change this var, so it differs at runtime of the hitched function
			var localVar = "notest";
		};

		Example.prototype = {
			property: "test",
			eTest: null,

			showProperty1: function(arg) {
				(epages.lang.hitch(this, this.showProperty2, [this.property + arg]))();
			},

			showProperty2: function(arg) {
				epagesLangHitchShowResults(this.eTest, this.property + arg);
 			}
		};

	  new Example(eTest);

	  var buttons = document.getElementsByTagName("input");
	  for (var i = 0; i < buttons.length; i++) {
	  	var button = buttons[i];
	  	button.click();
	  }

		function /*Boolean*/ epagesLangHitchShowResults(/*epages.Test*/eTest, value) {
			eTest.ok((value == "testtesttest") == expected[counter++], 'testtesttest => ' + value);
		}
	}
});
