dojo.provide("epages.uimessagehandler");
dojo.require("epages.epages");
dojo.require("epages.html.element");
dojo.require("epages.widget");
dojo.require("dojox.fx");
dojo.require("dojo.fx.easing");
dojo.require("epages.io.translation");
dojo.require('epages.widget.Message');

dojo.mixin( epages.uimessagehandler, {
	template :'<div id="busyMessageLayer"    style="position: absolute; left:0px; top:0px; height: 100%; width: 100%; z-index: 100000; overflow: auto; display: none;">' +
						'<div id="busyMessageUnderlay" style="position: absolute; left:0px; top:0px; height: 100%; width: 100%; z-index: 99999; background: #707070; opacity: 0.9; filter:alpha(opacity=90);" ></div>' +
						'<div id="busyMessageBox"      style="position: relative; left:0px; top:300px; z-index: 100000; max-width: 200px; overflow: visible; margin: auto; color: #000;">' +
						'<div class="Layer"><div id="busyMessagePropertyContainer" class="PropertyContainer" style="height:45px;padding-top:1px;"><div id="busyMessage" style="background:#f7f7f7;filter:alpha();zoom:1;margin: 5px 8px" ></div>' +
						'<span style="#display:none"><object id="busyMessageAnimation" class=" ShowElement" wmode="transparent" width="16" height="16" type="application/x-shockwave-flash" data="' + window.StoreRoot + '/Flash/loadingring.swf"><param name="movie" value="' + window.StoreRoot + '/Flash/loadingring.swf"/><param name="bgcolor" value="#f7f7f7"/></object></span>' +
						'</div></div><div class="LayerFooter"><div class="PropertyContainer"></div></div></div></div>',
	fadeOutBusyLayer: function(duration) {
		if(document.all) {
			setTimeout(function() {
				$("busyMessageAnimation").parentNode.style.display = "none";
			}, 500);
		}
		dojo.fx.combine([
			dojo.fadeOut({
				node:$('busyMessageLayer'),
				onEnd: function() {
					$('busyMessageLayer').style.display='none';
					if(document.all) {
						dojo.body().parentNode.style.overflow = "auto";
					}
				},
				duration: duration ? duration : 1000
			})
		]).play();
	},
	rePositionBusy: function() {
		if($("busyMessageLayer")) {
			$("busyMessageLayer").style.top = (window.pageYOffset || document.getElementsByTagName("html")[0].scrollTop) + "px";
		}
	},
	errorsToString : function(errors) {
		var errorMessage = '';
		for(var el in errors) {
			if(errors[el].Message != "") {
				errorMessage += errors[el].Message+"<br />";
			} else {
				var t = epages.io.dictionary.get(errors[el].Reason);
				if(t === undefined) t=errors[el].Reason;
				errorMessage += t+"<br />"
			}
		}
		return errorMessage;
	}
});

dojo.subscribe("uimessage/show", function(/* String */headline, /* String */message, /* String */ type, /* Object */ opt) {
/*
	headline -> string
	message  -> string
	type     -> string: Bubble, Dialog, Insert
	options  -> object

options type: Bubble
	* x          -> number
	* y	  	     -> number
	* typeClass  -> string: Error, Warning, Notification, Question, Tip
	* sizeClass  -> string: Large, Medium, Small
	* attachNode -> dom node (bubble will be attached as childnode) (optional)

options type: Insert
	* targetNode -> DOM object
	* typeClass  -> string: Error, Warning, Notification, Question, Tip, Confirmation
	* sizeClass  -> string: Large, Medium, Small

options type: Dialog
	* titleBar   -> string
	* typeClass  -> string: Error, Warning, Notification, Question, Tip, Confirmation
	* sizeClass  -> string: Large, Medium, Small
	* buttons    -> array: see ModalDialog widget
	* width      -> number: width of dialog
*/

	var sizeClass = (opt.sizeClass !== undefined) ? opt.sizeClass : "Large";
	var typeClass = (opt.typeClass !== undefined) ? opt.typeClass : "Warning";

	// hide old dialog / bubble
	if($$('uimessage_dialog')) $$('uimessage_dialog').hide();
	if($$('uimessage_bubble')) $$('uimessage_bubble').hide();

	var messageWidget = $$('uimessage_insert');

	if(messageWidget === undefined) {
		messageWidget = new epages.widget.Message({
			id: "uimessage_insert",
			headline: (headline !== undefined) ? headline : "",
			message:   message,
			sizeClass: sizeClass,
			typeClass: typeClass,
			borderClass: (type=='Insert') ? "WithBorder" : ""
		});
	} else {
		messageWidget.hide();
		messageWidget.setupContent({
			headline: headline,
			message: message,
			sizeClass: sizeClass,
			typeClass: typeClass,
			borderClass: (type=='Insert') ? "WithBorder" : ""
		});
	}
	messageWidget.show();
	switch(type) {
		case "Bubble":
			var bubbleWidget = $$('uimessage_bubble');
			var attachNode = opt.attachNode || document.body;
			// if not given, determine x and y by element
			if ((opt.x == null || opt.y == null) && opt.element != null) {
				var absPos = $E(opt.element).getAbsolutePosition(opt.baseNode);
				opt.x = opt.x || (absPos.x + opt.element.offsetWidth / 2);
				opt.y = opt.y || (absPos.y + opt.element.offsetHeight);
			}
			if(bubbleWidget === undefined) {
				dojo.require('epages.widget.Bubble');
				bubbleWidget = new epages.widget.Bubble({
					id: "uimessage_bubble",
					options:{
						x : opt.x,
						y : opt.y,
						typeClass: typeClass,
						content: messageWidget,
						orientation: opt.orientation
					}
				});
				attachNode.appendChild(bubbleWidget.domNode);
			} else {
				bubbleWidget.setupContent({
					x : opt.x,
					y : opt.y,
					typeClass: typeClass,
					content: messageWidget,
					orientation: opt.orientation
				});
				attachNode.appendChild(bubbleWidget.domNode);
			}
			bubbleWidget.show();
			break;
		case "Insert":
			if(opt.targetNode !== undefined) {
				opt.targetNode.appendChild($$('uimessage_insert').domNode);
			} else
				console.warn("uimessage/show: opt.targetNode is undefined");
			break;
		default:
			var buttons = opt.buttons;
			if (buttons === undefined) {
					var translation = epages.io.dictionary.translation;
					buttons = typeClass == 'Confirmation' ?
					[{
						label: translation.get('Yes'),
						onclick: function() {
							this._modalDialogWidget.hide();
							if (typeof opt.onYes == 'function') opt.onYes();
							}
					},{
						label: translation.get('No'),
						onclick: function() {
							this._modalDialogWidget.hide();
							if (typeof opt.onNo == 'function') opt.onNo();
						}
					}] :
					[{
						label: translation.get('Close'),
						onclick: function() { this._modalDialogWidget.hide(); }
					}]
			}
			var title= opt.titleBar;
			if (title === undefined) {
				title = epages.io.dictionary.translation.get(typeClass);
			}

			var uid = $$('uimessage_dialog');
			if(uid === undefined) {
				dojo.require('epages.widget.Modaldialog');
				uid = new epages.widget.Modaldialog({
					id: "uimessage_dialog",
					options:{
						title : title,
						width : (opt.width) ? opt.width : 450,
						content: messageWidget
					},
					buttons: buttons
				});
				document.body.appendChild(uid.domNode);
			} else {
				uid.containerNode.appendChild(messageWidget.domNode);
				uid.setupContent({
					title: title,
					width : 450,
					content: messageWidget,
					buttons: buttons
				});
			}
			uid.show();
			break;
	}
});

dojo.subscribe("uimessage/hide", function(opt) {
	if($$('uimessage_dialog')) $$('uimessage_dialog').hide();
	if($$('uimessage_bubble')) $$('uimessage_bubble').hide();
	if($$('uimessage_insert')) $$('uimessage_insert').hide();
});

dojo.subscribe("uimessage/startBusy", function(/* * */ owner, /* ?HTML String */ message, /* ?url */ iconUrl) {

	epages.uimessagehandler.busyLayerOwner = owner;
	epages.vars.BusyLayerActive = true;
	if(message === undefined){
		var translation = epages.io.dictionary.translation;
		message = translation.get('PleaseWait');
	}

	var bodyNode = document.getElementsByTagName("body")[0];

	if(document.all) {
		bodyNode.parentNode.style.overflow = "hidden";
	}

	var busyUnderlay=$('busyMessageLayer');
	if(busyUnderlay == null) {
		busyUnderlay= document.createElement("div");
		busyUnderlay.innerHTML = epages.uimessagehandler.template;
		bodyNode.appendChild(busyUnderlay.firstChild);
		busyUnderlay=busyUnderlay.firstChild;
	}
	$('busyMessageLayer').style.display='';
	dojo.style($('busyMessageLayer'), "opacity", 1);

	if($('busyMessage').getElementsByTagName("div")[0]) {
		$('busyMessage').removeChild($('busyMessage').getElementsByTagName("div")[0]);
	}
	var container = document.createElement("div");
	container.innerHTML = message;
	$('busyMessage').appendChild(container);

	if(iconUrl) {
		$('busyMessage').style.paddingLeft="40px";
		$('busyMessage').style.backgroundImage="url(" + iconUrl + ")";
		if($('busyMessage').style.filter) {
			$('busyMessage').style.backgroundImage = "none";
			$('busyMessage').style.filter = "progid:DXImageTransform.Microsoft.Alpha() progid:DXImageTransform.Microsoft.AlphaImageLoader(src='" + iconUrl + "', sizingMethod='crop)";
		}
		$('busyMessage').style.backgroundRepeat="no-repeat";
		$('busyMessage').style.minHeight="40px";
		$("busyMessagePropertyContainer").style.height = "58px";
		$("busyMessageAnimation").style.cssText = "position:absolute;bottom:12px;left:88px;#left:87px";
	}else {
		$('busyMessage').style.paddingLeft="0";
		$('busyMessage').style.backgroundImage="none";
		$('busyMessage').style.filter = "alpha()";
		$("busyMessagePropertyContainer").style.height = "48px";
		$("busyMessageAnimation").style.cssText = "position:absolute;bottom:12px;left:88px;#left:87px";
	}

	epages.uimessagehandler.rePositionBusy();

	$("busyMessageAnimation").parentNode.style.display = "";

});

dojo.subscribe("uimessage/showErrors", function(/* String */headline, /* String */titlebar, /* Object */ errors) {
	var errorMessage = epages.uimessagehandler.errorsToString(errors);

	dojo.publish("uimessage/show", [headline, errorMessage, "Dialog" , {
		titleBar  : titlebar,
		typeClass : "Error"
	}]);
});

dojo.subscribe("uimessage/showErrorBubble", function(/* String */headline, /* String */attachNode, /* Object */ errors, /* string ?*/ typeClass) {
	var tc = (typeClass) ? typeClass : "Error";
	var errorMessage = epages.uimessagehandler.errorsToString(errors);
	var pos = $E(attachNode).getAbsolutePosition();
	dojo.publish("uimessage/show", [headline, errorMessage, "Bubble" , {
		typeClass : tc,
		sizeClass : "Small",
		x: pos.x,
		y: pos.y + attachNode.clientHeight + 4
	}]);
});

dojo.subscribe("uimessage/changeBusy", function(owner, message) {
	if(epages.uimessagehandler.busyLayerOwner == owner && top.$("busyMessage")) {
		if(epages.Browser.engine == "MSIE") {
			$('busyMessage').style.display = "inline-block";
		}
		if($('busyMessage').getElementsByTagName("div")[0]) {
			$('busyMessage').removeChild($('busyMessage').getElementsByTagName("div")[0]);
		}
		var container = document.createElement("div");
		container.innerHTML = message;
		$('busyMessage').appendChild(container);
		if(epages.Browser.engine == "MSIE") {
			$('busyMessage').style.display = "block";
		}
	}
});

dojo.subscribe("uimessage/stopBusy", function(owner, timeout, duration) {
	if(epages.uimessagehandler.busyLayerOwner == owner) {
		if(timeout) {
			window.setTimeout(function() {
				epages.vars.BusyLayerActive = false;
				epages.uimessagehandler.fadeOutBusyLayer(duration);
				}, timeout)
		}else {
			epages.vars.BusyLayerActive = false;
			epages.uimessagehandler.fadeOutBusyLayer(duration);
		}
	}
});

dojo.connect(window, "scroll", this, epages.uimessagehandler.rePositionBusy);
