/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

  epages.widget $Revision: 1.28.2.2 $

*/

dojo.provide("epages.widget");
dojo.require("epages.epages");
dojo.require("epages.browser");
dojo.require("epages.lang.hash");
dojo.require("dijit.dijit"); // load all on one
dojo.require("dojo.parser");
dojo.require("dijit._Widget");
dojo.require('dijit._Templated');
//dojo.require('epages.profile'); // use this to measure time for creating widgets

epages.topDojo.publish('epages/addGlobalSymbol', ['$$', window]);

if (window.restrictedParent || $$ === undefined) {
	$$ = function(widgetId) {
		for (var i = 0; i < epages._windows.length; i++) {
			if (epages._windows[i].dijit != null && typeof epages._windows[i].dijit.byId == "function") {
				var widget = epages._windows[i].dijit.byId(widgetId);
				if (widget) return widget;
			}
		}
	};
}

epages.widget.parserClasses = $H();
dojo.parser.instantiateOrg = dojo.parser.instantiate;
dojo.parser.instantiate = function(nodes) {
	var w = epages.widget.parserClasses;
	if(epages.Browser.engine != "Presto") {
		var d = dojo;
		d.forEach(nodes, function(node){
			if(!node){ return; }
			var type = node.getAttribute("dojoType");
			if((!type)||(!type.length)||w.existsKey(type)){ return; }
			w.set(type,1);
			if (!dojo.isFunction(dojo.getObject(type))) {
				console.debug('add this to you script: dojo.%s("%s");', 'require', type);
				d.require(type);
			}
		});
	}
	return this.instantiateOrg(nodes);
};

dojo.declare("epages.widget.Popup",
	[dijit._Widget],
	{
		parent: '',					// the button etc. that is displaying this popup
		around: '',					// DOM node (typically a button); place popup relative to this node.
		hideOnBlur: false,	// flag - hide popup on blur
		o: {orient: {'BR':'TR','BL':'TL'}},	// orientation parameters
		_visible:   false,	// current visibility status of popup

		show: function() {
			// summary: show popup
			var h = {
				popup: this,
				parent: this.parent,
				around: this.around
			};

			dojo.mixin(h,this.o);
			dijit.popup.open(h);
			this._visible=true;
			dijit.focus(this.domNode);
			if(epages.zIndex) {
				this.domNode.parentNode.style.zIndex=epages.zIndex;	// set z-index of wrapper div
				epages.zIndex+=1;
			}
		},

		hide: function() {
			// summary: hide popup
			dijit.popup.close(this);
		},

		toggle: function () {
			// summary: toggle visibility of popup
			if (this._visible) {
				this.hide();
			} else {
				this.show();
			}
		},

		onClose: function () {
			// summary: event function close popup
			this._visible=false;
		},

		_onBlur: function () {
			// summary: blur event function
			if (this.hideOnBlur) this.hide();
		}
	}
);

// register window for global widget registry
epages.onIframeStart.push(function() {
	dijit.registerWin(window);
});

//remove comment if you want to measure widget creating time
/*dojo.require('epages.lang.hitch');
dijit._Widget.prototype.create_profile = dijit._Widget.prototype.create;
dijit._Widget.prototype.create = function(){
	var me = this;
	var args = arguments;
	epages.profile.takeStatistik(me.declaredClass,function(){
		me.create_profile.apply(me,args);
	});
};

window.setTimeout(function(){
	epages.profile.showStatistik();
},25000);
*/

