/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.
*/
dojo.provide("epages.widget.DeleteFileOnServer");
dojo.require("epages.widget");
dojo.require("epages.string");
dojo.require('epages.format');
dojo.require('epages.io.translation');

dojo.declare(
	"epages.widget.DeleteFileOnServer",
	[ dijit._Widget, dijit._Templated ],
	{
		_fileSizeText: '',
		
		fileName:  '',
		fileSize:  '',
		filePath :  '',
		confirm :  'true',
		url:       '?',
		newWindowFeature: 'PopUp',
		displayfileName: '',
		headlineConfirm: epages.io.dictionary.get('HeadLineDeleteFile'), // 'Moechten Sie diese Datei wirklich loeschen?',
		messageConfirm:  epages.io.dictionary.get('File')+(':'), // 'Datei',
		titleConfirm:    epages.io.dictionary.get('TitleDeleteFile'), // 'Datei loeschen',
		altDelete:   epages.io.dictionary.get('TitleDeleteFile'), //'Datei loeschen',
		altView:     epages.io.dictionary.get('TitleViewFile'), //'Datei anzeigen',

		objectId:      epages.vars.ObjectID || '',
		changeAction:  'DeleteFile',
		fileAttribute: '',
		languageId:    '',
		onSuccess:     '',
		onPreview:     '',

		imagePath: epages.themeUrl('images'),
		templateString: '<span><i dojoAttachEvent="onclick:onConfirm" class="ClickIcon ico_s_delete Sprite" title="${altDelete}"></i> <a dojoAttachEvent="onclick:onConfirm" href="#">${altDelete}</a>${_fileSizeText}</span>',

		postMixInProperties: function () {
			this.inherited("postMixInProperties", arguments);
			this.confirm = epages.string.toBoolean(this.confirm);
			if (this.fileSize != '') this._fileSizeText = ' (' + this.fileSize +')';
			this.displayfileName=epages.format.scrunch(this.fileName,35);
		},

		onExecution: function (response) {
			if (response.error == null) {
				// EPG-10737 dirty cache
				if(typeof(window.pc_active) != "undefined" && window.pc_active == true) {
					pageCache_SetStatus(true);
				}
				if (typeof this.onSuccess == 'function') {
					this.onSuccess();
				} else {
					eval(this.onSuccess);
				}
			}
			this.domNode.style.display = 'none';
		},

		onExecute: function () {
			dojo.require('epages.io.json');
			var json = new epages.io.Json();
			json.loadAsync(this.url, dojo.hitch(this, 'onExecution'), {
				'ObjectID': this.objectId,
				'ChangeAction': this.changeAction,
				'File': this.fileAttribute,
				'DeleteLanguageID': this.languageId,
				'ACCEPT': this.confirm ? 1 : 0
			});
		},

		onConfirm: function (evt) {
			dojo.stopEvent(evt);
			if(this.confirm) {
				dojo.require("epages.uimessagehandler");
				dojo.publish("uimessage/show", [
					this.headlineConfirm,
					this.messageConfirm + ' ' + this.fileName, 'Dialog', {
						titleBar:  this.titleConfirm,
						sizeClass: 'Large',
						typeClass: 'Confirmation',
						onYes:     dojo.hitch(this, 'onExecute')
					}]);
			} else {
				this.onExecute();
			}
		}
	}
);
