-- #104
CREATE TABLE ebayauction (
    auctionid            int           not null
,   shopid               int           not null
,   productid            int           null
,   ebayshopenvironmentid int           null
,   ebayusertemplateid   int           null
,   externalauctionid    varchar(30)   null
,   ebayuuid             varchar(32)   null
,   name                 nvarchar(255)  not null
,   subtitle             nvarchar(255)  null
,   ebaycategoryid       int           null
,   listingtype          varchar(30)   not null
,   quantity             int           null
,   startprice           money         null
,   duration             int           null
,   scheduletype         int           not null
,   scheduletime         datetime      null
,   isbuyitnowenabled    bit           not null
,   buyitnowprice        money         null
,   isprivate            bit           not null
,   hitcounter           varchar(30)   null
,   isboldtitle          bit           not null
,   ishighlight          bit           not null
,   isbordered           bit           not null
,   isfeatured           bit           not null
,   ishomepagefeatured   bit           not null
,   gallery              varchar(30)   null
,   pictureurl           varchar(255)  null
,   galleryurl           varchar(255)  null
,   status               tinyint       null
,   currentbid           money         null
,   bidcount             int           null
,   starttime            datetime      null
,   endtime              datetime      null
,   description          text          null
,   isgetitfast          bit           not null
,   secondcategoryid     int           null
,   isnew                bit           not null
,   acceptsreturnpolicy  bit           not null
,   dispatchtimemax      int           null
,   conditionid          int           null
,   auctiontemplateid    int           null
,   isdefaultauction     bit           not null
,   usertemplateonly     bit           not null

,   constraint pk_ebayauction                   primary key (auctionid)
,   constraint fk_ebayauction_object            foreign key (auctionid)
        references object                           (objectid)
,   constraint fk_ebayauction_shop              foreign key (shopid)
        references shop                             (shopid)
,   constraint fk_ebayauction_product           foreign key (productid)
        references product                          (productid)
,   constraint fk_ebayauction_ebayshopenviron   foreign key (ebayshopenvironmentid)
        references ebayshopenvironment              (ebayshopenvironmentid)
,   constraint fk_ebayauction_ebayusertemplat   foreign key (ebayusertemplateid)
        references ebayusertemplate                 (ebayusertemplateid)
,   constraint fk_ebayauction_ebayauction       foreign key (auctiontemplateid)
        references ebayauction                      (auctionid)
)
GO
CREATE INDEX i_auction_shop ON ebayauction (shopid)
GO
CREATE INDEX i_auction_product ON ebayauction (productid)
GO
CREATE INDEX i_auction_shopenvironment ON ebayauction (ebayshopenvironmentid, externalauctionid)
GO
CREATE INDEX i_auction_usertemplate ON ebayauction (ebayusertemplateid)
GO
CREATE INDEX i_auction_status ON ebayauction (status)
GO
CREATE INDEX i_auction_templateid ON ebayauction (auctiontemplateid)
GO
