-- #104
CREATE TABLE ebayauction (
     auctionid            integer  not null
,    shopid               integer  not null
,    productid            integer  null
,    ebayshopenvironmentid integer  null
,    ebayusertemplateid   integer  null
,    externalauctionid    varchar(30)  null
,    ebayuuid             varchar(32)  null
,    name                 varchar(255)  not null
,    subtitle             varchar(255)  null
,    ebaycategoryid       integer  null
,    listingtype          varchar(30)  not null
,    quantity             integer  null
,    startprice           decimal(19,4)  null
,    duration             integer  null
,    scheduletype         integer  not null
,    scheduletime         datetime  null
,    isbuyitnowenabled    bool  not null
,    buyitnowprice        decimal(19,4)  null
,    isprivate            bool  not null
,    hitcounter           varchar(30)  null
,    isboldtitle          bool  not null
,    ishighlight          bool  not null
,    isbordered           bool  not null
,    isfeatured           bool  not null
,    ishomepagefeatured   bool  not null
,    gallery              varchar(30)  null
,    pictureurl           varchar(255)  null
,    galleryurl           varchar(255)  null
,    status               tinyint  null
,    currentbid           decimal(19,4)  null
,    bidcount             integer  null
,    starttime            datetime  null
,    endtime              datetime  null
,    description          longtext  null
,    isgetitfast          bool  not null
,    secondcategoryid     integer  null
,    isnew                bool  not null
,    acceptsreturnpolicy  bool  not null
,    dispatchtimemax      integer  null
,    conditionid          integer  null
,    auctiontemplateid    integer  null
,    isdefaultauction     bool  not null
,    usertemplateonly     bool  not null

,   constraint pk_ebayauction                   primary key (auctionid)
,   constraint fk_ebayauction_object            foreign key (auctionid)
        references object                           (objectid)
,   constraint fk_ebayauction_shop              foreign key (shopid)
        references shop                             (shopid)
,   constraint fk_ebayauction_product           foreign key (productid)
        references product                          (productid)
,   constraint fk_ebayauction_ebayshopenviron   foreign key (ebayshopenvironmentid)
        references ebayshopenvironment              (ebayshopenvironmentid)
,   constraint fk_ebayauction_ebayusertemplat   foreign key (ebayusertemplateid)
        references ebayusertemplate                 (ebayusertemplateid)
,   constraint fk_ebayauction_ebayauction       foreign key (auctiontemplateid)
        references ebayauction                      (auctionid)
)
GO
CREATE INDEX i_auction_shop ON ebayauction (shopid)
GO
CREATE INDEX i_auction_product ON ebayauction (productid)
GO
CREATE INDEX i_auction_shopenvironment ON ebayauction (ebayshopenvironmentid, externalauctionid)
GO
CREATE INDEX i_auction_usertemplate ON ebayauction (ebayusertemplateid)
GO
CREATE INDEX i_auction_status ON ebayauction (status)
GO
CREATE INDEX i_auction_templateid ON ebayauction (auctiontemplateid)
GO
