IF OBJECT_ID('i_EbayAuction') IS NOT NULL
    DROP PROCEDURE i_EbayAuction
GO
CREATE PROCEDURE i_EbayAuction (
    @AuctionID            int
,   @ShopID               int
,   @ProductID            int          = null
,   @EbayShopEnvironmentID int          = null
,   @EbayUserTemplateID   int          = null
,   @ExternalAuctionId    varchar(30)  = null
,   @EbayUUID             varchar(32)  = null
,   @Name                 nvarchar(255)
,   @SubTitle             nvarchar(255) = null
,   @EbayCategoryId       int          = null
,   @ListingType          varchar(30)
,   @Quantity             int          = null
,   @StartPrice           money        = null
,   @Duration             int          = null
,   @ScheduleType         int
,   @ScheduleTime         datetime     = null
,   @IsBuyItNowEnabled    bit
,   @BuyItNowPrice        money        = null
,   @IsPrivate            bit
,   @HitCounter           varchar(30)  = null
,   @IsBoldTitle          bit
,   @IsHighlight          bit
,   @IsBordered           bit
,   @IsFeatured           bit
,   @IsHomePageFeatured   bit
,   @Gallery              varchar(30)  = null
,   @PictureUrl           varchar(255) = null
,   @GalleryUrl           varchar(255) = null
,   @Status               tinyint      = null
,   @CurrentBid           money        = null
,   @BidCount             int          = null
,   @StartTime            datetime     = null
,   @EndTime              datetime     = null
,   @IsGetItFast          bit
,   @SecondCategoryId     int          = null
,   @IsNew                bit
,   @AcceptsReturnPolicy  bit
,   @DispatchTimeMax      int          = null
,   @ConditionID          int          = null
,   @AuctionTemplateID    int          = null
,   @IsDefaultAuction     bit          
,   @UserTemplateOnly     bit          
) AS BEGIN
    DECLARE @TransactionCount int
    SELECT @TransactionCount = @@trancount

    IF @TransactionCount > 0 SAVE  TRANSACTION ti_ebayauction
    ELSE                     BEGIN TRANSACTION ti_ebayauction

        INSERT INTO ebayauction
               ( auctionid, shopid, productid, ebayshopenvironmentid, ebayusertemplateid, externalauctionid, ebayuuid, name, subtitle, ebaycategoryid, listingtype, quantity, startprice, duration, scheduletype, scheduletime, isbuyitnowenabled, buyitnowprice, isprivate, hitcounter, isboldtitle, ishighlight, isbordered, isfeatured, ishomepagefeatured, gallery, pictureurl, galleryurl, status, currentbid, bidcount, starttime, endtime, isgetitfast, secondcategoryid, isnew, acceptsreturnpolicy, dispatchtimemax, conditionid, auctiontemplateid, isdefaultauction, usertemplateonly)
        SELECT  @AuctionID,@ShopID,@ProductID,@EbayShopEnvironmentID,@EbayUserTemplateID,@ExternalAuctionId,@EbayUUID,@Name,@SubTitle,@EbayCategoryId,@ListingType,@Quantity,@StartPrice,@Duration,@ScheduleType,@ScheduleTime,@IsBuyItNowEnabled,@BuyItNowPrice,@IsPrivate,@HitCounter,@IsBoldTitle,@IsHighlight,@IsBordered,@IsFeatured,@IsHomePageFeatured,@Gallery,@PictureUrl,@GalleryUrl,@Status,@CurrentBid,@BidCount,@StartTime,@EndTime,@IsGetItFast,@SecondCategoryId,@IsNew,@AcceptsReturnPolicy,@DispatchTimeMax,@ConditionID,@AuctionTemplateID,@IsDefaultAuction,@UserTemplateOnly

        IF NOT @@transtate IN (0, 1)
        BEGIN
            ROLLBACK TRANSACTION ti_ebayauction
            RETURN 1
        END

    IF @TransactionCount = 0
        COMMIT TRANSACTION ti_ebayauction
    RETURN 0
END
GO
