IF OBJECT_ID('i_EbayAuctionPaymentMethod') IS NOT NULL
    DROP PROCEDURE i_EbayAuctionPaymentMethod
GO
CREATE PROCEDURE i_EbayAuctionPaymentMethod (
    @EbayAuctionPaymentMethodID int          
,   @EbayAuctionID        int          
,   @EbayPaymentMethodID  int          
,   @CODCost              money        = null
) AS BEGIN
    DECLARE @TransactionCount int
    SELECT @TransactionCount = @@trancount

    IF @TransactionCount > 0 SAVE  TRANSACTION ti_ebayauctionpaymentmethod
    ELSE                     BEGIN TRANSACTION ti_ebayauctionpaymentmethod

        INSERT INTO ebayauctionpaymentmethod
               ( ebayauctionpaymentmethodid, ebayauctionid, ebaypaymentmethodid, codcost)
        SELECT  @EbayAuctionPaymentMethodID,@EbayAuctionID,@EbayPaymentMethodID,@CODCost

        IF NOT @@transtate IN (0, 1)
        BEGIN
            ROLLBACK TRANSACTION ti_ebayauctionpaymentmethod
            RETURN 1
        END

    IF @TransactionCount = 0
        COMMIT TRANSACTION ti_ebayauctionpaymentmethod
    RETURN 0
END
GO
