IF OBJECT_ID('i_EbayAuctionShippingLocation') IS NOT NULL
    DROP PROCEDURE i_EbayAuctionShippingLocation
GO
CREATE PROCEDURE i_EbayAuctionShippingLocation (
    @EbayAuctionShippingLocationID int          = null
,   @EbayAuctionID        int          = null
,   @EbayShippingLocationID int          = null
,   @EbayShippingMethodID int          = null
,   @Price                money        = null
,   @AdditionalPrice      money        = null
) AS BEGIN
    DECLARE @TransactionCount int
    SELECT @TransactionCount = @@trancount

    IF @TransactionCount > 0 SAVE  TRANSACTION ti_ebayauctionshippinglocation
    ELSE                     BEGIN TRANSACTION ti_ebayauctionshippinglocation

        IF @EbayAuctionShippingLocationID IS NULL SELECT @EbayAuctionShippingLocationID = 1 + max(ebayauctionshippinglocationid) FROM ebayauctionshippinglocation HOLDLOCK
        IF @EbayAuctionShippingLocationID IS NULL SELECT @EbayAuctionShippingLocationID = 1

        INSERT INTO ebayauctionshippinglocation
               ( ebayauctionshippinglocationid, ebayauctionid, ebayshippinglocationid, ebayshippingmethodid, price, additionalprice)
        SELECT  @EbayAuctionShippingLocationID,@EbayAuctionID,@EbayShippingLocationID,@EbayShippingMethodID,@Price,@AdditionalPrice

        IF NOT @@transtate IN (0, 1)
        BEGIN
            ROLLBACK TRANSACTION ti_ebayauctionshippinglocation
            RETURN 1
        END

    IF @TransactionCount = 0
        COMMIT TRANSACTION ti_ebayauctionshippinglocation
    RETURN 0
END
GO
