IF OBJECT_ID('i_EbayAuctionShippingMethod') IS NOT NULL
    DROP PROCEDURE i_EbayAuctionShippingMethod
GO
CREATE PROCEDURE i_EbayAuctionShippingMethod (
    @EbayAuctionShippingMethod int          
,   @EbayAuctionID        int          
,   @EbayShippingMethodID int          
,   @Price                money        = null
,   @AdditionalPrice      money        = null
) AS BEGIN
    DECLARE @TransactionCount int
    SELECT @TransactionCount = @@trancount

    IF @TransactionCount > 0 SAVE  TRANSACTION ti_ebayauctionshippingmethod
    ELSE                     BEGIN TRANSACTION ti_ebayauctionshippingmethod

        INSERT INTO ebayauctionshippingmethod
               ( ebayauctionshippingmethod, ebayauctionid, ebayshippingmethodid, price, additionalprice)
        SELECT  @EbayAuctionShippingMethod,@EbayAuctionID,@EbayShippingMethodID,@Price,@AdditionalPrice

        IF NOT @@transtate IN (0, 1)
        BEGIN
            ROLLBACK TRANSACTION ti_ebayauctionshippingmethod
            RETURN 1
        END

    IF @TransactionCount = 0
        COMMIT TRANSACTION ti_ebayauctionshippingmethod
    RETURN 0
END
GO
