IF OBJECT_ID('i_EbayCustomerMap') IS NOT NULL
    DROP PROCEDURE i_EbayCustomerMap
GO
CREATE PROCEDURE i_EbayCustomerMap (
    @ShopID               int          
,   @EbayShopEnvironmentID int          
,   @EbayUserName         varchar(255) 
,   @CustomerID           int          
) AS BEGIN
    DECLARE @TransactionCount int
    SELECT @TransactionCount = @@trancount

    IF @TransactionCount > 0 SAVE  TRANSACTION ti_ebaycustomermap
    ELSE                     BEGIN TRANSACTION ti_ebaycustomermap

        INSERT INTO ebaycustomermap
               ( shopid, ebayshopenvironmentid, ebayusername, customerid)
        SELECT  @ShopID,@EbayShopEnvironmentID,@EbayUserName,@CustomerID

        IF NOT @@transtate IN (0, 1)
        BEGIN
            ROLLBACK TRANSACTION ti_ebaycustomermap
            RETURN 1
        END

    IF @TransactionCount = 0
        COMMIT TRANSACTION ti_ebaycustomermap
    RETURN 0
END
GO
