IF OBJECT_ID('i_EbayEnvironment') IS NOT NULL
    DROP PROCEDURE i_EbayEnvironment
GO
CREATE PROCEDURE i_EbayEnvironment (
    @EbayEnvironmentID    int
,   @EbaySiteId           int
,   @EbaySiteCode         varchar(30)
,   @IsSandBox            bit
,   @IsVisible            bit
,   @CurrencyID           varchar(3)
,   @LanguageID           varchar(2)
,   @IconPath             varchar(255)
,   @ApiUrl               varchar(255)
,   @WebUrl               varchar(255)
,   @SignInUrl            varchar(255)
,   @Name                 nvarchar(255) = null
,   @LocaleID             varchar(5)   = null
,   @HasGetItFast         bit
,   @AttrSetIDCondition   int          = null
) AS BEGIN
    DECLARE @TransactionCount int
    SELECT @TransactionCount = @@trancount

    IF @TransactionCount > 0 SAVE  TRANSACTION ti_ebayenvironment
    ELSE                     BEGIN TRANSACTION ti_ebayenvironment

        INSERT INTO ebayenvironment
               ( ebayenvironmentid, ebaysiteid, ebaysitecode, issandbox, isvisible, currencyid, languageid, iconpath, apiurl, weburl, signinurl, name, localeid, hasgetitfast, attrsetidcondition)
        SELECT  @EbayEnvironmentID,@EbaySiteId,@EbaySiteCode,@IsSandBox,@IsVisible,@CurrencyID,@LanguageID,@IconPath,@ApiUrl,@WebUrl,@SignInUrl,@Name,@LocaleID,@HasGetItFast,@AttrSetIDCondition

        IF NOT @@transtate IN (0, 1)
        BEGIN
            ROLLBACK TRANSACTION ti_ebayenvironment
            RETURN 1
        END

    IF @TransactionCount = 0
        COMMIT TRANSACTION ti_ebayenvironment
    RETURN 0
END
GO
