IF OBJECT_ID('i_EbayShopEnvironment') IS NOT NULL
    DROP PROCEDURE i_EbayShopEnvironment
GO
CREATE PROCEDURE i_EbayShopEnvironment (
    @EbayShopEnvironmentID int          
,   @ShopID               int          
,   @EbayEnvironmentID    int          
,   @EbayTokenExpiryDate  datetime     = null
,   @EbayUserName         varchar(255) = null
,   @EbayCountry          varchar(2)   = null
,   @EbayRegion           int          = null
,   @EbayLocation         varchar(255) = null
,   @Name                 nvarchar(255) = null
,   @LastUpdate           datetime     = null
,   @EbayPostalCode       varchar(32)  = null
) AS BEGIN
    DECLARE @TransactionCount int
    SELECT @TransactionCount = @@trancount

    IF @TransactionCount > 0 SAVE  TRANSACTION ti_ebayshopenvironment
    ELSE                     BEGIN TRANSACTION ti_ebayshopenvironment

        INSERT INTO ebayshopenvironment
               ( ebayshopenvironmentid, shopid, ebayenvironmentid, ebaytokenexpirydate, ebayusername, ebaycountry, ebayregion, ebaylocation, name, lastupdate, ebaypostalcode)
        SELECT  @EbayShopEnvironmentID,@ShopID,@EbayEnvironmentID,@EbayTokenExpiryDate,@EbayUserName,@EbayCountry,@EbayRegion,@EbayLocation,@Name,@LastUpdate,@EbayPostalCode

        IF NOT @@transtate IN (0, 1)
        BEGIN
            ROLLBACK TRANSACTION ti_ebayshopenvironment
            RETURN 1
        END

    IF @TransactionCount = 0
        COMMIT TRANSACTION ti_ebayshopenvironment
    RETURN 0
END
GO
