IF OBJECT_ID('i_EbayTemplate') IS NOT NULL
    DROP PROCEDURE i_EbayTemplate
GO
CREATE PROCEDURE i_EbayTemplate (
    @EbayTemplateID       int          
,   @Name                 nvarchar(255) = null
,   @Image                varchar(255) = null
) AS BEGIN
    DECLARE @TransactionCount int
    SELECT @TransactionCount = @@trancount

    IF @TransactionCount > 0 SAVE  TRANSACTION ti_ebaytemplate
    ELSE                     BEGIN TRANSACTION ti_ebaytemplate

        INSERT INTO ebaytemplate
               ( ebaytemplateid, name, image)
        SELECT  @EbayTemplateID,@Name,@Image

        IF NOT @@transtate IN (0, 1)
        BEGIN
            ROLLBACK TRANSACTION ti_ebaytemplate
            RETURN 1
        END

    IF @TransactionCount = 0
        COMMIT TRANSACTION ti_ebaytemplate
    RETURN 0
END
GO
