﻿ /*
  Copyright (c) 2006-2010, epages Software GmbH
  All Rights Reserved.
  
*/

dojo.provide('epages.cartridges.de_epages.externalcontent.googletranslate');
dojo.require('epages.cartridges.de_epages.design.mcecontent');

epages.cartridges.de_epages.externalcontent.GoogleTranslate = epages.Class();

dojo.extend(epages.cartridges.de_epages.externalcontent.GoogleTranslate,
  epages.cartridges.de_epages.design.MceContent.prototype, {
  contentClass    : 'epages.cartridges.de_epages.externalcontent.GoogleTranslate',
  title           : 'Google Translate',
  width			  : 200,															//integer
  height		  : 45,																//integer
  type            : undefined,
  preview         : epages.vars.StoreRoot + '/BO/icons/navelement_googletranslate.png',

 /**
 * initialise google translate object
 * @param {Integer} timestamp
 */
  LOAD: function (timestamp) {
    new google.translate.TranslateElement({pageLanguage: epages.vars.Locale.language}, 'google_translate_element'+timestamp);
  },
/**
 * creates the gadgets content / appends necessary scripts to dom
 * @param {String} info
 * @param {DOMObject} headNode
 * @param {String} customScript
 */
  contentString: function (info,headNode,customScript) {
    var timestamp = (new Date()).getTime();
    var aStrings = [
      '\n',
      '<div id="google_translate_element'+ timestamp +'"></div>'
    ];
	var requestType = "http";
	// use https if site is secured
	if(epages.vars.RequestProtocolAndServer){
		var a = epages.vars.RequestProtocolAndServer.split(":");
		if(a && a.length>0){
			requestType = a[0];
		}
	}
    aStrings = aStrings.join("\n");
	
	// location of the google translate api / cb ... callback
	var googleSrc = requestType + '://translate.google.com/translate_a/element.js?cb=cb' + timestamp;
	var scriptHTML = 'window.cb' + timestamp + ' = function(){';
	if(customScript){
		scriptHTML += customScript;
	}
	scriptHTML += 'dojo["require"]("epages.cartridges.de_epages.externalcontent.googletranslate"); epages.cartridges.de_epages.externalcontent.GoogleTranslate.prototype.LOAD("' + timestamp + '");};';
	if (headNode) {
		// in preview mode the scripts need to be created to get parsed
		dojo.create("script", {
			'type': 'text/javascript',
			'innerHTML': scriptHTML
		}, headNode);
		
		dojo.create("script", {
			'type': 'text/javascript',
			'src': googleSrc
		}, headNode);
	} else {
		// in normal mode they can be inserted as strings
		aStrings += '<script type="text/javascript">'+scriptHTML+'</script>';
    	aStrings += '<script type="text/javascript" src="'+googleSrc+'"></script>';
	}
	return aStrings;
  },
  /**
   * load the gadget in the preview iframe in MBO
   * @param {Object} domObject
   * @override epages.cartridges.de_epages.design.mcecontent
   */
  loadPreview: function (domObject){
	var iframe = this.getIframeDocument(domObject);
	var iframeHead = iframe.getElementsByTagName('head')[0];
	var iframeBody = iframe.getElementsByTagName('body')[0];
	if(!iframeHead || !iframeBody){
		//stop processing if iframe isn't fully created yet
		return;
	}
	var customScript = [
	  'dojo.create("style",{',
	  ' "type"      : "text/css",',
	  '	"innerHTML" : ".mceShowContent{top:0px!important;}.goog-te-banner-frame{ visibility:hidden!important;}"',
	  '},document.getElementsByTagName("head")[0]);',
	  'document.getElementsByTagName("body")[0].removeAttribute("style");'
    ];
	
	customScript = customScript.join("\n");
	iframeBody.innerHTML = this.contentString({},iframeHead,customScript);
  }
});

