IF OBJECT_ID('i_GoogleAnalyticsAction') IS NOT NULL
    DROP PROCEDURE i_GoogleAnalyticsAction
GO
CREATE PROCEDURE i_GoogleAnalyticsAction (
    @ActionID             int          
,   @GoogleAnalyticsPageName varchar(255) = null
,   @GoogleAnalyticsTarget varchar(255) = null
) AS BEGIN
    DECLARE @TransactionCount int
    SELECT @TransactionCount = @@trancount

    IF @TransactionCount > 0 SAVE  TRANSACTION ti_googleanalyticsaction
    ELSE                     BEGIN TRANSACTION ti_googleanalyticsaction

        INSERT INTO googleanalyticsaction
               ( actionid, googleanalyticspagename, googleanalyticstarget)
        SELECT  @ActionID,@GoogleAnalyticsPageName,@GoogleAnalyticsTarget

        IF NOT @@transtate IN (0, 1)
        BEGIN
            ROLLBACK TRANSACTION ti_googleanalyticsaction
            RETURN 1
        END

    IF @TransactionCount = 0
        COMMIT TRANSACTION ti_googleanalyticsaction
    RETURN 0
END
GO
