-- #104
CREATE TABLE amazonoffer (
     amazonofferid        integer  not null
,    productid            integer  null
,    currencyid           char(3)  not null
,    amazoncatalogid      integer  null
,    amazonproducttypeid  integer  null
,    portalconfigid       integer  null
,    amazonprice          decimal(10,4)  null
,    laststocklevel       float  null
,    laststockupdate      datetime  null
,    onlinestatus         tinyint  not null
,    lastbestpriceupdate  datetime  null
,    bestprice            decimal(10,4)  null
,    ispricechanged       smallint  not null
,    parentofferid        integer  null
,    asin                 varchar(11)  null

,   constraint pk_amazonitemprice               primary key (amazonofferid)
,   constraint fk_amazonoffer_currency          foreign key (currencyid)
        references currency                         (currencyid)
,   constraint fk_amazonoffer_portalconfig      foreign key (portalconfigid)
        references portalconfig                     (portalconfigid)
,   constraint fk_amazonoffer_object            foreign key (amazonofferid)
        references object                           (objectid)
,   constraint fk_amazonoffer_amazoncatalog     foreign key (amazoncatalogid)
        references amazoncatalog                    (amazoncatalogid)
,   constraint fk_amazonoffer_amazonproductty   foreign key (amazonproducttypeid)
        references amazonproducttype                (amazonproducttypeid)
,   constraint fk_amazonoffer_product           foreign key (productid)
        references product                          (productid)
,   constraint fk_amazonoffer_amazonoffer       foreign key (parentofferid)
        references amazonoffer                      (amazonofferid)
)
GO
CREATE UNIQUE INDEX u_portalconfigid_productid ON amazonoffer (portalconfigid, productid ASC)
GO
CREATE INDEX i_productid ON amazonoffer (productid)
GO
CREATE INDEX i_amazonitemprice ON amazonoffer (amazonofferid ASC)
GO
CREATE INDEX i_portalconfigid_status ON amazonoffer (portalconfigid, onlinestatus)
GO
CREATE CLUSTERED INDEX i_parentofferid ON amazonoffer (parentofferid)
GO
