use Test::Simple tests => 5;

use strict;
use DE_EPAGES::Core::API::Script qw(RunScript);
use DE_EPAGES::Mail::API::SMTP;

RunScript(
    Sub => \&Main
);

sub Main {

    my $smtp = DE_EPAGES::Mail::API::SMTP->new( 'mail', 25 );
    ok( $smtp, "new connection" );

    $smtp->openConnection;
    ok( $smtp->existsConnection, "openConnection" );
    
    $smtp->sendDataToSMTP('testmail testmail', {
        'BCC' => [],
        'CC' => [],
        'FROM' => 'Milestones <Milestones@epages.de>',
        'HEADER_ENC' => 'utf-8',
        'REPLY' => undef,
        'SUBJECT' => "testmail testmail",
        'SkipBadRecipients' => 1,
        'TO' => [
          'm.mustermann@epages.de'
        ]
      });
    ok( 1, "sendDataToSMTP" );
    
    my $res;
    package DE_EPAGES::Mail::API::SMTP;
    $res = EncodeHeader( 'iso-8859-1', 'Mhh', 'Reply-To' );   

    ##no critic (ProhibitMultiplePackages)
    package main; 
    ok( $res eq "=?iso-8859-1?Q?M=E4=E4hh?=", "encode header" );
    ##use critic
    
    $smtp->closeConnection;
    ok( !$smtp->existsConnection, "closeConnection" );
}

