dojo.provide("epages.cartridges.de_epages.mediagallery.widget.ImageInlineEditor");
epages.require('ep_shop_upload', 'epages.uploader');
dojo.require('epages.cartridges.de_epages.presentation.widget.InlineEditor');

dojo.declare(
	"epages.cartridges.de_epages.mediagallery.widget.ImageInlineEditor",
	[epages.cartridges.de_epages.presentation.widget.InlineEditor],
	{
		/* widget properties */
		templateString		: '',
		templatePath      : dojo.moduleUrl('epages.cartridges.de_epages.mediagallery.widget','templates/ImageInlineEditor.html'),
		widgetsInTemplate : true,
		objectId          : epages.vars.ObjectID || '',
		uploadAction      : 'UploadImages',
		scaleWidth        : null,
		scaleHeight       : null,

		/* public properties */
		permanent: true,

		postCreate: function(){			
			if(this.value == ''){
				this.imgNode.src = epages.themeUrl('images') + "/plain.gif";
				this.imgNode.width= 50;
				this.imgNode.height = 50;
			}

			if(this.scaleWidth != null) {
				this.scaleWidth = parseInt(this.scaleWidth);
			}
			if(this.scaleHeight != null) {
				this.scaleHeight = parseInt(this.scaleHeight);
			}

			// modify changeaction
			this._changeUploader();

			this.inherited('postCreate', arguments);
		},

		startup: function() {			
			dojo.subscribe('InlineEditor_' + this.id + '/onUploadFinished', dojo.hitch(this, function(opt) {
				this.onChange(opt.uploadedObjectFiles[0],opt.uploadedFiles[0]);
			}));
			this.inherited('startup', arguments);
			this.domNode.title = "";

		},

		_changeUploader: function () {			
			var uploaderAction = '?ChangeAction='+this.uploadAction+'&ObjectID=' + this.objectId;
			if(this.uploadNode && (this.scaleWidth != null || this.scaleHeight != null)) {
				if(this.scaleWidth != null) {
					uploaderAction += '&Width='+ this.scaleWidth;
				}
				if(this.scaleHeight != null) {
					uploaderAction += '&Height='+ this.scaleHeight;
				}
			}
			dojo.attr(this.uploadNode, 'onclick',
				"epages.Uploader.open({" +
					"action : '" + uploaderAction + "'," +
          "multiple : false," +
          "reloadPage : false," +
          "id : '" + this.uploadNode.id + "'" +
        "});");      
		},

		onChange: function(value,imgSrc) {
			this.imgNode.src = imgSrc;
			// write contents back to hidden input
			this.contentNode.value = value;
			this.undoObject.addInput(this.contentNode);
		},

		show: function(evt) {
			// Upload widget
			//this.uploadNode.uploadFiles(evt);
		},

		hide: function() {
			// this is a permanent widget, so it never hides
		},

		_copyStyle: function(){
			//description: empty function from parent widget is not used in this widget
		}

	}
);


