/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.mediagallery.widget.Toolmediagallery $Revision: 1.32.4.1 $

*/
dojo.provide("epages.cartridges.de_epages.mediagallery.widget.Toolmediagallery");
dojo.require('epages.widget.LocalizedWidget');
dojo.require("epages.browser");
dojo.require("epages.html.element");

dojo.declare(
	"epages.cartridges.de_epages.mediagallery.widget.Toolmediagallery",
	[epages.widget.LocalizedWidget],
	{
		/**
		 * public properties
		 */
		attributeName : '',                    /*  BackgoundImage  */
		storeRoot     : epages.vars.StoreRoot, /* '/WebRoot/Store' */
		siteId        : epages.vars.SiteID,    /* 12345 */
		url           : '?',                   /* '/epages/DemoShop.admin?' */
		// default is "standard", for possible values see "_templateMapping"
		// "invisible" does not show anything
		isTinyMCE     : "false",			// flag: use mediagalllery to insert into tinymce
		multiSelect     : "true",			// media gallery option: enable multiselect
		onApply         : "",					// media gallery option: apply function
		applyButtonLabel: "",					// media gallery option: label text for apply button
		validFileTypes  : "",    			// media gallery option: filter file extension list - show only these
		/**
		 * constants
		 */
		MEDIAGALLERY_OFFSET_X: 130,
		MEDIAGALLERY_OFFSET_Y: 130,

		/**
		 * private properties
		 */
		templateType       : "standard",
		defaultTemplateType: "standard",
		templatePath       : dojo.moduleUrl('epages.cartridges.de_epages.mediagallery.widget', 'templates/Toolmediagallery.html'),
		translationName    : dojo.moduleUrl('epages.cartridges.de_epages.mediagallery.widget', 'templates/translation'),
		_templateMapping : {
			standard  : 'Toolmediagallery.html',
			icon      : 'ToolmediagalleryIcon.html',
			invisible : 'ToolmediagalleryInvisible.html'
		},
		_tinyMceSelection   : undefined,
		/**
		 * widget properties
		 */
		imagePath       : dojo.moduleUrl('dijit', 'themes/epages/images'),

		postMixInProperties: function(){
			this._templateDirectory = dojo.moduleUrl('epages.cartridges.de_epages.mediagallery.widget' , 'templates');
			this.inherited("postMixInProperties", arguments);
		},

		postCreate  : function() {
			this.inherited("postCreate", arguments);
			// toolmediagallery as tiny mce button
			this.isTinyMCE = (this.isTinyMCE == 'true' || this.isTinyMCE == '1');

			// tinymce button display settings
			if(this.isTinyMCE && this.imageNode)
				this.imageNode.style.margin="2px";

			this._appendEvents();
		},

		/**
		 * private methods
		 */

		_appendEvents: function() {
			// open gallery
			dojo.connect(this.domNode, 'onclick', this, 'openDialog');
		},

		setFileTypes: function(/* String */ fileTypes) {
			// summary: updates the list of allowed file extensions

			if(typeof(fileTypes) === "string" && (this.validFileTypes != fileTypes)) {
				this.validFileTypes = fileTypes;
				var MediaGallery = $$('MediaGallery');
				if(MediaGallery !== undefined) {
					MediaGallery.setFileTypes(this.validFileTypes);
				}
			}
		},

		openDialog: function(/*Event*/evt) {
			// summary: Show MediaGallery
			// description: Calls show() of the mediagallery widget (widgetId=MediaGallery)

			if(!this.isMediaSelected && !this.isImageSelected) {
				var MediaGallery = $$('MediaGallery');
				// set onApply function
				var onApply = '';
				if(this.onApply != "") {
					onApply=this.onApply;
				} else if (this.isTinyMCE) {
					var me = this;
					onApply= function(selected) {
						var generatedHtml="";
						$A(selected).each(function (el) {
							generatedHtml+=me.mceGenerateContent(el)+'<br />';
						});
						me.mceInsertContent(generatedHtml);
					};
				}
				if(MediaGallery === undefined) {
					epages.require('ep_shop_tree','dijit.Tree');
					epages.require('ep_shop_upload','epages.uploader');
					epages.require('ep_mediagallery', 'epages.cartridges.de_epages.mediagallery.widget.Mediagallery');
					MediaGallery = new epages.cartridges.de_epages.mediagallery.widget.Mediagallery({
						id:               'MediaGallery',
						siteId:           this.siteId,
						url:              this.url,
						applyButtonLabel: this.applyButtonLabel,
						multiSelect:      this.multiSelect,
						validFileTypes:   this.validFileTypes,
	 					onApply:          onApply
					});

					document.getElementsByTagName("body")[0].appendChild(MediaGallery.domNode);
				} else {
					MediaGallery.setOnApply(onApply);
				}
				MediaGallery.show();
			}
		},

		mceGenerateContent: function(el) {
			epages.require('ep_mediagallery', 'epages.cartridges.de_epages.mediagallery.Mimetypehtml');
			var html= getHtmlByMimeType(el.mimetype, {src: el.fullpath, name: el.title}, true);
			return html;
		},

		mceInsertContent: function (html) {
			if(tinyMCE && tinyMCE.activeEditor){
				tinyMCE.activeEditor.selection.moveToBookmark(tinymce.WindowManager.bookmark);
				tinyMCE.activeEditor.execCommand('mceInsertContent', false, html);
			}
		}

	}
);