use strict;
use Test::Simple tests => 2;
use DE_EPAGES::PayPalPro::API::PayflowPro qw (CallpayFlowPro);
use DE_EPAGES::Core::API::Script qw( RunScript );
use DE_EPAGES::Database::API::Connection qw( ConnectTestSite DisconnectSite );
use DE_EPAGES::Object::API::Factory qw (LoadRootObject);
use DE_EPAGES::Order::API::Constants;

local $ENV{'EPAGES_TESTSITE'} = 'Store';

sub Main {
    ConnectTestSite();
    # ok( Init(), 'initialization' );

    my $System = LoadRootObject();

    #--- check payment process
    my %Params = (
        'TRXTYPE'     => 'A',
        'ACCT'        => '4111111111111111',
        'AMT'         => '1.67',
        'CURRENCY'    => 'GBP',
        'EXPDATE'     => '0707',
        'FIRSTNAME'   => 'Klaus',
        'LASTNAME'    => 'Klausen',
        'TENDER'      => 'C',
        'USER'        => 'xxxxxxx',
        'VENDOR'      => 'xxxxxxx',
        'PWD'         => 'xxxxxxx',
        'PARTNER'     => 'xxxxxxx'
    );

    my $hResult = CallpayFlowPro(\%Params,1);

    ok($hResult->{'RESPMSG'} eq 'Invalid vendor account');
    ok($hResult->{'RESULT'} == 26);

    # ok( Cleanup(), 'cleanup' );
    DisconnectSite();
}

#sub Cleanup {
#    return 1;
#}
#
#sub Init {
#    return 1;
#}

RunScript(Sub=>\&Main, Debug=>1);
