-- #203
CREATE TABLE users (
    userid               int           not null
,   localeid             char(5)       not null
,   currencyid           char(3)       not null
,   password             varchar(64)   not null
,   isactivated          bit           not null
,   deleteconfirmation   bit           not null
,   islogincookieallowed bit           not null
,   ishtmlemailallowed   bit           not null
,   reminderquestion     nvarchar(200)  null
,   challengephrase      nvarchar(200)  null
,   email                nvarchar(150)  null
,   countloginfailure    int           null
,   lastloginfailure     datetime      null
,   showhistory          bit           not null
,   name                 nvarchar(255)  null
,   isemailverified      bit           not null

,   constraint pk_user                          primary key (userid)
,   constraint fk_users_trustee                 foreign key (userid)
        references trustee                          (trusteeid)
,   constraint fk_users_currency                foreign key (currencyid)
        references currency                         (currencyid)
,   constraint fk_users_locale                  foreign key (localeid)
        references locale                           (localeid)
) LOCK DATAROWS
GO
CREATE INDEX i_user_email ON users (email)
GO
