/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.presentation.widget.Toolfont $Revision: 1.22.4.1 $

*/
dojo.provide("epages.cartridges.de_epages.presentation.widget.Toolcolor");
dojo.require("epages.widget.LocalizedWidget");
dojo.require("epages.browser");
dojo.require("epages.html.element");
dojo.require("epages.cartridges.de_epages.presentation.widget.Colorpicker");

dojo.declare(
	"epages.cartridges.de_epages.presentation.widget.Toolcolor",
	[epages.widget.LocalizedWidget],
	{
		/**
		 * public properties
		 */
		label               : '',
		color               : '',
		colorType           : '',     /* Background, ListeHeadBAckground, ... */
		isBackgroundColor   : 'false',
		templateType        : "tablerow",
		defaultTemplateType : "tablerow", // read-only!
		isTinyMCE           : 'false',
		'class'             : '',
		/**
		 * private properties
		 */
		_templateMapping:{
			tablerow          : 'Toolcolor.html',
			colorbox          : 'Toolcolorbox.html',
			palette           : 'Toolcolorpalette.html',
			xlicon            : 'Toolcolorxlicon.html'
		},
		_palette            : 'fore',
		_tinyMceSelection   : undefined,
		/**
		 * constants
		 */
		COLORPICKER_OFFSET_X: 18,
		COLORPICKER_OFFSET_Y: 0,
		/**
		 * widget properties
		 */
		templatePath    : dojo.moduleUrl('epages.cartridges.de_epages.presentation.widget', 'templates/Toolcolor.html'),
		imagePath       : epages.themeUrl('images'),
		translationName : dojo.moduleUrl('epages.cartridges.de_epages.presentation.widget', 'templates/translation'),
		userColors: epages.vars.userColors,
		currentWizardScheme: 'Compound',
		objectId: '',

		postMixInProperties: function() {
			this._templateDirectory = dojo.moduleUrl('epages.cartridges.de_epages.presentation.widget', 'templates');
			this.inherited("postMixInProperties", arguments);
			this.isBackgroundColor = epages.string.toBoolean(this.isBackgroundColor);
			this.isTinyMCE = epages.string.toBoolean(this.isTinyMCE);
			this._palette = this.isBackgroundColor ? 'back' : 'fore';
			if(this.color === '') this.color = 'transparent';
		},

		postCreate  : function() {
                        // summary: Initialize widget: append events
			this.inherited("postCreate", arguments);
			
			dojo.addClass(this.domNode,this['class']);
			if(this.objectId=='')
				this.colorInputNode.name=this.colorType;
			this._appendEvents();
			this._changeColorBoxColor();
		},

		/**
		 * private methods
		 */

		_appendEvents: function() {
                        // summary: append events to buttons (bold, italic, underline)
			dojo.connect(this.colorInputNode,     'onchange', this, '_changeColorBoxColor');

			// save selection in editor iframe for msie
			if (this.isTinyMCE && epages.Browser.engine == "MSIE")
				dojo.connect(this.clickNode, 		    'onmousedown', this, '_tinyMceSaveSelection');

			// open color picker
			if(this.clickNode)
				dojo.connect(this.clickNode, 		    'onclick', this, '_openColorPicker');
			else
				dojo.connect(this.colorBoxNode,     'onclick', this, '_openColorPicker');
		},

		_changeColorBoxColor: function() {
			// summary: set background color of color preview box
			var color=this.colorInputNode.value;
			this.colorBoxNode.style.backgroundColor=color;
			if(color=='transparent')
				dojo.addClass(this.colorBoxNode,"Transparent")
			else
				dojo.removeClass(this.colorBoxNode,"Transparent")
			if (this.isTinyMCE && tinyMCE.selectedInstance != null)
				if(this._tinyMceSelection === undefined)
					tinyMCE.execCommand((this.isBackgroundColor ? 'HiliteColor': 'forecolor'), false, color);
				else { // IE only
					this._tinyMceSelection.execCommand((this.isBackgroundColor ? 'BackColor': 'forecolor'), false, color);
					tinyMCE.activeEditor.focus();
					tinyMCE.activeEditor.selection.setRng(this._tinyMceSelection);
					this._tinyMceSelection=undefined;
				}
		},

		_openColorPicker: function(/*Event*/evt) {
			// summary: Show ColorPicker
			// description: Calls show() of the colorpicker widget (widgetId=ColorPicker) and passes
			var colorPicker = $$('ColorPicker');
			if(colorPicker === undefined) {
				colorPicker = new epages.cartridges.de_epages.presentation.widget.Colorpicker({	id: 'ColorPicker' });
				document.getElementsByTagName("body")[0].appendChild(colorPicker.domNode);
			}
			colorPicker.setColorInput(this.colorInputNode,(this.isBackgroundColor));
			var openHereNode=(this.clickNode) ? this.clickNode : this.colorBoxNode;
			colorPicker.show(openHereNode);
		},

		_tinyMceSaveSelection: function() {
			//var iframeDoc = $E(tinyMCE.selectedInstance.iframeElement).getIframeDocument();
			if(tinyMCE.activeEditor && tinyMCE.activeEditor.selection){
				this._tinyMceSelection = tinyMCE.activeEditor.selection.getRng();
			}

		}
	});

