use Test::Simple tests => 4;
use strict;
use DateTime;
use DE_EPAGES::Presentation::API::Session qw (GenerateSessionID);

my $dt = DateTime->new(
    year    => 2005,
    month   => 2,
    day     => 28,
    hour    => 10,
    minute  => 10,
);

ok ($dt->day_of_week < 6, 'weekday ' . $dt->day_name );
ok ($dt->epoch, 'epoch');


my $SessionID1 = GenerateSessionID();
ok (length($SessionID1) == 32, 'SessionID fine');

my $findDoubleSessionID = 0;
my %SessionIDs;
for(my $i=0;$i<100000 && !$findDoubleSessionID;$i++) {
    my $SessionID = GenerateSessionID();
    if (exists $SessionIDs{$SessionID}) {
        $findDoubleSessionID = $i;
    }
    $SessionIDs{$SessionID} = undef;
}
ok (!$findDoubleSessionID , '100000 created SessionIDs ' . ($findDoubleSessionID ? "(found double at $findDoubleSessionID)" : 'not equal'));
