﻿use Test::Simple tests => 4;
use strict;
use DE_EPAGES::Core::API::Error qw( ExistsError );
use DE_EPAGES::Product::API::Product qw(TestUPCEAN);


#UPC Version A (12 digits)
eval { TestUPCEAN('UPC Version A', '768268019959'); }; 
ok( !ExistsError(), "TestUPCEAN('UPC Version A', '768268019959');" );

#UPC Version E (8 digits)
eval { TestUPCEAN('UPC Version E', '01234565'); }; 
ok( !ExistsError(), "TestUPCEAN('UPC Version E', '01234565');" );


#EAN-13
eval { TestUPCEAN('EAN-13', '4004764007974'); }; 
ok( !ExistsError(), "TestUPCEAN('EAN-13', '4004764007974');" );

#EAN-8
eval { TestUPCEAN('EAN-8', '40151601'); }; 
ok( !ExistsError(), "TestUPCEAN('EAN-8', '40151601');" );



#==============================================================================
package BasePackage;

sub new {
    my $class = shift;
    return bless { @_ }, $class;
}

#==============================================================================
##no critic(ProhibitMultiplePackages)
package TestPackage;
##use critic
BEGIN {
    @TestPackage::ISA = qw( BasePackage );
}

sub new {
    my $class = shift;
    return bless { @_ }, $class;
}
