use strict;
use Test::Simple tests => 6;
use DE_EPAGES::Core::API::Script qw( RunScript );
use DE_EPAGES::Object::API::TestXML qw (SixTestsXML);
use DE_EPAGES::ShopConfiguration::API::XML::CartridgeRefImportHandler qw (ImportCartridgeRefs);
use DE_EPAGES::ShopConfiguration::API::XML::CartridgeRefDeleteHandler qw (DeleteCartridgeRefs);
use DE_EPAGES::Database::API::Connection qw( ConnectToSite DisconnectSite );

local $ENV{'EPAGES_TESTSITE'} = 'Site';

my @OBJECTS = ('Stores', 'Providers');

sub Initial {
    ConnectToSite();
    DeleteCartridgeRefs('initial.xml');
    ImportCartridgeRefs('initial.xml');
    DisconnectSite();
}

sub Cleanup {
    ConnectToSite();
    DeleteCartridgeRefs('initial.xml');
    DisconnectSite();
}

RunScript(Sub => sub {
    Initial();
    SixTestsXML (\@OBJECTS);
    Cleanup();
}, Debug=>1);
