use Test::Simple tests => 1;

use strict;
use DE_EPAGES::Core::API::Script qw ( RunScript );
use DE_EPAGES::Database::API::Connection qw ( ConnectToSite DisconnectSite );
use DE_EPAGES::Object::API::Factory qw ( LoadRootObject );

sub Main {
    local $| = 1;
    ConnectToSite();
    Cleanup();

    my $Store = LoadRootObject()->folder('Stores')->insertChild('Store', {'Alias'=>'TestStore', 'Name'=>'TestStore', 'DBPassword'=>'thomas'});
    ok ($Store->id, 'store created');

    Cleanup();
    DisconnectSite();
}

sub Cleanup {
    my $System = LoadRootObject();
    $System->folder('Stores')->child('TestStore')->delete if $System->folder('Stores')->existsChild('TestStore');
}

RunScript(
    'Sub' => \&Main
);

1;

